/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_config.c 951 2008-04-14 08:51:11Z ertl-honda $
 */

/*
 * åװ¸⥸塼AT91SKYEYEѡ
 */

#include "kernel_impl.h"
#include <sil.h>
#include "target_serial.h"

/*
 * Ƴߤγ׵ػߥե饰ξ
 */
uint32_t idf;

/*
 * ߤγͥ٥ޥ
 */
PRI ipm;
 
/*
 *  °ꤵƤ뤫Ƚ̤뤿ѿ
 */
uint32_t bitpat_cfgint;

/*
 *  åȰ¸ν
 */
void
target_initialize(void)
{
	/*
	 *  ARM¸ν
	 */
	core_initialize();
    
	/*
	 * Ƴߤγ׵ػߥե饰ػ
	 */
	idf = ~0U;

	/*
	 * ͥ٥ޥ0
	 */ 
	ipm = 0U;

	/*
	 * Ƥγߤޥ
	 */ 
	at91skyeye_disable_int(~0U);

	/*
	 * ٤Ƥγߤ
	 */
	at91skyeye_clear_int(~0U);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ롥
	 */
	bitpat_cfgint = 0U;
    
	/*
	 *  target_fput_logȤ褦UART
	 */
	at91skyeye_init_uart();    
}

/*
 *  åȰ¸νλ
 */
void
target_exit(void)
{
	extern void    software_term_hook(void);
	void (*volatile fp)(void) = software_term_hook;

	/*
	 *  software_term_hookؤΥݥ󥿤򡤰övolatileΤfp
	 *  ƤȤΤϡ0ȤӤŬǺʤ褦ˤ뤿
	 *  Ǥ롥
	 */
	if (fp != 0) {
		(*fp)();
	}

	/*
	 *  ARM¸νλ
	 */
	core_terminate();

	/*
	 *  ٤Ƥγߤޥ롥
	 */
	at91skyeye_disable_int(~0U);

	/*
	 *  ȯĶ¸νλ
	 */
	at91skyeye_exit();

	while(1);
}

/*
 *  ƥ٥ϤΤʸ
 */
void
target_fput_log(char_t c)
{
	if (c == '\n') {
		at91skyeye_putc('\r');
	}
	at91skyeye_putc(c);
}

/*
 *  ׵饤°
 *
 *  ASPͥǤѤꤷơѥ᡼顼ϥǥ
 *  Ƥ롥FI4ͥѤˤϡ顼֤褦ˤ٤
 *  Ǥ
 *
 */
void
x_config_int(INTNO intno, ATR intatr, PRI intpri)
{
	assert(VALID_INTNO(intno));
	assert(TMIN_INTPRI <= intpri && intpri <= TMAX_INTPRI);

	/*
	 *  °ꤵƤ뤫Ƚ̤뤿ѿ
	 */
	bitpat_cfgint |= INTNO_BITPAT(intno);
    
	/* 
	 * äߤػߤ
	 */    
	x_disable_int(intno);

	if ((intatr & TA_ENAINT) != 0U){
		(void)x_enable_int(intno);
	}    
}

#ifndef OMIT_DEFAULT_INT_HANDLER
/*
 * ̤γߤäν
 */
void
default_int_handler(void){
	syslog_0(LOG_EMERG, "Unregistered Interrupt occurs.");
	target_exit();
}
#endif /* OMIT_DEFAULT_INT_HANDLER */
